#!/usr/bin/env python3.9

# Déjà, on de-hash les ints
# https://stackoverflow.com/questions/17393911/reverse-the-hash-function-in-python

def hashInt(x):
	P = 2**61 - 1
	if (x == -1):
		return -2
	if (x < 0):
		return -hashInt(-x)
	return x % P;

def unhashInt(x):
	return x;	# -1 n'existe pas

#for x in range(-100000,100000):
#	y = x * 10000
#	rev = unhashInt(y)
#	if (hash(rev) != y):
#		print(f"Target: {y =}")
#		print(f"My reverse: {rev =}")
#		print(f"Hash of this reverse: {hash(rev) =}")
#		exit(1)
#
#print("OK, unhash int marche")
#exit(0)

# https://github.com/python/cpython/blob/3.9/Objects/tupleobject.c#L360
ranged = 100
modulo = 2**64
l = 2

xxprime1 = 11400714785074694791
xxprime2 = 14029467366897019727
xxprime5 = 2870177450012600261

def design(x):	# Revenir à un int non-signé comme mon algo recodé
	while x < 0:
		x += modulo
	return x

def xor(x,y):	# j'ai pas trouvé en sage: "^" est vu comme "puissance"
	r = 0
	for i in range(1, 64):
		x1 = (x % (2**i)) >=(2**(i-1))
		y1 = (y % (2**i)) >=(2**(i-1))
		if ((x1 and not y1) or (not x1 and y1)):
			r += (2**(i-1))
	return r

def xxrotate(x):
	return (((x << 31)%modulo) | ((x >> 33)%modulo))

def unxxrotate(x):
	return (((x >> 31)%modulo) + ((x << 33)%modulo))
#	return (((x << 31)%modulo) | ((x >> 33)%modulo))
	
def hashStepByStep(a,b):
	myhash = 0
	acc = xxprime5 % modulo
#	print(f"ReHash {acc = }")
	lane = hashInt(a)	# Normalement, jamais "-1"
#	print(f"ReHash {lane = }")
	acc = (acc + ((lane * xxprime2) % modulo)) % modulo
#	print(f"ReHash {acc = }")
	acc = xxrotate(acc) % modulo
#	print(f"ReHash {acc = }")
	acc = (acc * xxprime1) % modulo
#	print(f"ReHash {acc = }")

	lane = hashInt(b)	# Pareil, jamais -1
#	print(f"ReHash {lane = }")
	acc = (acc + ((lane * xxprime2) % modulo)) % modulo
#	print(f"ReHash {acc = }")
	acc = xxrotate(acc) % modulo
#	print(f"ReHash {acc = }")
	acc = (acc * xxprime1) % modulo
#	print(f"ReHash {acc = }")

	acc = (acc + xor(l, xor(xxprime5, 3527539))) % modulo
#	print(f"ReHash {acc = }")
	if (acc == -1):
		myhash = 1546275796	# Ca, c'est possible
	else:
		myhash = acc
#	print(f"ReHash {myhash = }")
	if (myhash >= (modulo/2)):
		myhash -= modulo
	
#	print(f"ReHash {myhash = }")
	if (myhash != hash((a,b))):
		print(f"Algo de hashage planté!")
		print(f"a,b {(a,b) =}")
		print(f"Hash real: {hash((a,b)) =}")
		print(f"Hash calculé: {myhash =}")
		exit(1)

def deHash(rev):
#	print(f"DeHash {rev = }")
	
	myhash = rev	# Meme variables que pour le recoded-hash
	if (myhash < 0):
		myhash += modulo
#	print(f"DeHash {myhash = }")
	
	if (myhash == 1546275796):
		acc = -1
	else:
		acc = myhash
#	print(f"DeHash {acc = }")

	acc = design(acc - xor(l, xor(xxprime5, 3527539)))
#	print(f"DeHash {acc = }")
	
	# reverse the (acc * xxprime1)%modulo
	revacc = var('revacc')
	sols = solve_mod(acc == (revacc * xxprime1),modulo)
	acc = Integer(sols[0][0])
#	print(f"DeHash {acc = }")
	
	# reverse xxrotate(acc) % modulo
	acc = unxxrotate(acc)
#	print(f"DeHash {acc = }")
	
	# On va dire que l'on force cette valeur
	b = 42
	acc0 = acc
	while true:
		acc = acc0
		
		# reverse acc = (acc + ((lane * xxprime2) % modulo)) % modulo
		revacc = var('revacc')
		sols = solve_mod(acc == revacc + (b * xxprime2), modulo)
		acc = Integer(sols[0][0])
#		print(f"DeHash {acc = }")
		
		# reverse the (acc * xxprime1)%modulo
		revacc = var('revacc')
		sols = solve_mod(acc == (revacc * xxprime1),modulo)
		acc = Integer(sols[0][0])
#		print(f"DeHash {acc = }")
		
		# reverse xxrotate(acc) % modulo
		acc = unxxrotate(acc)
#		print(f"DeHash {acc = }")
		
		# reverse acc = (acc + ((lane * xxprime2) % modulo)) % modulo
		lane = var('lane')	# C'est ma vraie inconnue
		sols = solve_mod(acc == xxprime5 + (lane * xxprime2), modulo)
		lane = Integer(sols[0][0])
		if (lane >= (2**61)):
			# Lane cannot be over 2**61 - 1 
			# since it's the result of a hashInt
			# In such case, the "b" value I picked is impossible,
			# So let's just try again
			b += 1
			continue;
		
#		print(f"DeHash {sols = }")
#		print(f"DeHash {lane = }")
#		print(f"DeHash        {(2**61)-1}") # lane max
		
		a = unhashInt(lane)
		if (a > (modulo / 2)):
			a -= modulo
#		print(f"DeHash {a = }")
#		print(f"DeHash {b = }")
		
#		hashStepByStep(a,b)
#		exit()
		if (hash((a,b)) != rev):
			print(f"Algo de dé-hashage planté")
			print(f"{rev = }")
			print(f"{a = } {b = }")
			print(f"Actual hash={hash((a,b))}")
			exit(2)
		else:
			return (a,b)
	
	
#for rev in range(-100000,100000):
#	(x,y) = deHash(rev)
#	print(f"rev = {rev} = hash(({x},{y})) = {hash((x,y))}")
#
#print("OK TOUT MARCHE :D")
(x,y) = deHash(-707795099849905487)
print(x)
print(y)


