

# This file was *autogenerated* from the file ./reversed-hash.sage
from sage.all_cmdline import *   # import sage library

_sage_const_2 = Integer(2); _sage_const_61 = Integer(61); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_100 = Integer(100); _sage_const_64 = Integer(64); _sage_const_11400714785074694791 = Integer(11400714785074694791); _sage_const_14029467366897019727 = Integer(14029467366897019727); _sage_const_2870177450012600261 = Integer(2870177450012600261); _sage_const_31 = Integer(31); _sage_const_33 = Integer(33); _sage_const_3527539 = Integer(3527539); _sage_const_1546275796 = Integer(1546275796); _sage_const_42 = Integer(42); _sage_const_707795099849905487 = Integer(707795099849905487)#!/usr/bin/env python3.9

# Déjà, on de-hash les ints
# https://stackoverflow.com/questions/17393911/reverse-the-hash-function-in-python

def hashInt(x):
	P = _sage_const_2 **_sage_const_61  - _sage_const_1 
	if (x == -_sage_const_1 ):
		return -_sage_const_2 
	if (x < _sage_const_0 ):
		return -hashInt(-x)
	return x % P;

def unhashInt(x):
	return x;	# -1 n'existe pas

#for x in range(-100000,100000):
#	y = x * 10000
#	rev = unhashInt(y)
#	if (hash(rev) != y):
#		print(f"Target: {y =}")
#		print(f"My reverse: {rev =}")
#		print(f"Hash of this reverse: {hash(rev) =}")
#		exit(1)
#
#print("OK, unhash int marche")
#exit(0)

# https://github.com/python/cpython/blob/3.9/Objects/tupleobject.c#L360
ranged = _sage_const_100 
modulo = _sage_const_2 **_sage_const_64 
l = _sage_const_2 

xxprime1 = _sage_const_11400714785074694791 
xxprime2 = _sage_const_14029467366897019727 
xxprime5 = _sage_const_2870177450012600261 

def design(x):	# Revenir à un int non-signé comme mon algo recodé
	while x < _sage_const_0 :
		x += modulo
	return x

def xor(x,y):	# j'ai pas trouvé en sage: "^" est vu comme "puissance"
	r = _sage_const_0 
	for i in range(_sage_const_1 , _sage_const_64 ):
		x1 = (x % (_sage_const_2 **i)) >=(_sage_const_2 **(i-_sage_const_1 ))
		y1 = (y % (_sage_const_2 **i)) >=(_sage_const_2 **(i-_sage_const_1 ))
		if ((x1 and not y1) or (not x1 and y1)):
			r += (_sage_const_2 **(i-_sage_const_1 ))
	return r

def xxrotate(x):
	return (((x << _sage_const_31 )%modulo) | ((x >> _sage_const_33 )%modulo))

def unxxrotate(x):
	return (((x >> _sage_const_31 )%modulo) + ((x << _sage_const_33 )%modulo))
#	return (((x << 31)%modulo) | ((x >> 33)%modulo))
	
def hashStepByStep(a,b):
	myhash = _sage_const_0 
	acc = xxprime5 % modulo
#	print(f"ReHash {acc = }")
	lane = hashInt(a)	# Normalement, jamais "-1"
#	print(f"ReHash {lane = }")
	acc = (acc + ((lane * xxprime2) % modulo)) % modulo
#	print(f"ReHash {acc = }")
	acc = xxrotate(acc) % modulo
#	print(f"ReHash {acc = }")
	acc = (acc * xxprime1) % modulo
#	print(f"ReHash {acc = }")

	lane = hashInt(b)	# Pareil, jamais -1
#	print(f"ReHash {lane = }")
	acc = (acc + ((lane * xxprime2) % modulo)) % modulo
#	print(f"ReHash {acc = }")
	acc = xxrotate(acc) % modulo
#	print(f"ReHash {acc = }")
	acc = (acc * xxprime1) % modulo
#	print(f"ReHash {acc = }")

	acc = (acc + xor(l, xor(xxprime5, _sage_const_3527539 ))) % modulo
#	print(f"ReHash {acc = }")
	if (acc == -_sage_const_1 ):
		myhash = _sage_const_1546275796 	# Ca, c'est possible
	else:
		myhash = acc
#	print(f"ReHash {myhash = }")
	if (myhash >= (modulo/_sage_const_2 )):
		myhash -= modulo
	
#	print(f"ReHash {myhash = }")
	if (myhash != hash((a,b))):
		print(f"Algo de hashage planté!")
		print(f"a,b {(a,b) =}")
		print(f"Hash real: {hash((a,b)) =}")
		print(f"Hash calculé: {myhash =}")
		exit(_sage_const_1 )

def deHash(rev):
#	print(f"DeHash {rev = }")
	
	myhash = rev	# Meme variables que pour le recoded-hash
	if (myhash < _sage_const_0 ):
		myhash += modulo
#	print(f"DeHash {myhash = }")
	
	if (myhash == _sage_const_1546275796 ):
		acc = -_sage_const_1 
	else:
		acc = myhash
#	print(f"DeHash {acc = }")

	acc = design(acc - xor(l, xor(xxprime5, _sage_const_3527539 )))
#	print(f"DeHash {acc = }")
	
	# reverse the (acc * xxprime1)%modulo
	revacc = var('revacc')
	sols = solve_mod(acc == (revacc * xxprime1),modulo)
	acc = Integer(sols[_sage_const_0 ][_sage_const_0 ])
#	print(f"DeHash {acc = }")
	
	# reverse xxrotate(acc) % modulo
	acc = unxxrotate(acc)
#	print(f"DeHash {acc = }")
	
	# On va dire que l'on force cette valeur
	b = _sage_const_42 
	acc0 = acc
	while true:
		acc = acc0
		
		# reverse acc = (acc + ((lane * xxprime2) % modulo)) % modulo
		revacc = var('revacc')
		sols = solve_mod(acc == revacc + (b * xxprime2), modulo)
		acc = Integer(sols[_sage_const_0 ][_sage_const_0 ])
#		print(f"DeHash {acc = }")
		
		# reverse the (acc * xxprime1)%modulo
		revacc = var('revacc')
		sols = solve_mod(acc == (revacc * xxprime1),modulo)
		acc = Integer(sols[_sage_const_0 ][_sage_const_0 ])
#		print(f"DeHash {acc = }")
		
		# reverse xxrotate(acc) % modulo
		acc = unxxrotate(acc)
#		print(f"DeHash {acc = }")
		
		# reverse acc = (acc + ((lane * xxprime2) % modulo)) % modulo
		lane = var('lane')	# C'est ma vraie inconnue
		sols = solve_mod(acc == xxprime5 + (lane * xxprime2), modulo)
		lane = Integer(sols[_sage_const_0 ][_sage_const_0 ])
		if (lane >= (_sage_const_2 **_sage_const_61 )):
			# Lane cannot be over 2**61 - 1 
			# since it's the result of a hashInt
			# In such case, the "b" value I picked is impossible,
			# So let's just try again
			b += _sage_const_1 
			continue;
		
#		print(f"DeHash {sols = }")
#		print(f"DeHash {lane = }")
#		print(f"DeHash        {(2**61)-1}") # lane max
		
		a = unhashInt(lane)
		if (a > (modulo / _sage_const_2 )):
			a -= modulo
#		print(f"DeHash {a = }")
#		print(f"DeHash {b = }")
		
#		hashStepByStep(a,b)
#		exit()
		if (hash((a,b)) != rev):
			print(f"Algo de dé-hashage planté")
			print(f"{rev = }")
			print(f"{a = } {b = }")
			print(f"Actual hash={hash((a,b))}")
			exit(_sage_const_2 )
		else:
			return (a,b)
	
	
#for rev in range(-100000,100000):
#	(x,y) = deHash(rev)
#	print(f"rev = {rev} = hash(({x},{y})) = {hash((x,y))}")
#
#print("OK TOUT MARCHE :D")
(x,y) = deHash(-_sage_const_707795099849905487 )
print(x)
print(y)



